SystemOrganization addCategory: #'Neo4reSt-GraphModel'!

Object subclass: #N4GraphObject
	instanceVariableNames: 'db restClient id settings'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

N4GraphObject subclass: #N4GraphDb
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:31'!
createNode
	^ (N4Node from: self restClient createNode) db: self! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:31'!
createNode: properties
	^ (N4Node from: (self restClient createNode: properties)) db: self! !

!N4GraphDb methodsFor: 'printing' stamp: 'mu 12/24/2011 15:30'!
elementName
	^'db'! !

!N4GraphDb methodsFor: 'accessing' stamp: 'mu 12/21/2011 00:45'!
indexer
	^ N4Indexer on: self! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/23/2011 13:11'!
initialNode
	^self nodeAt: 0! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:30'!
nodeAt: id 
	| resp |
	resp := self restClient getNodeAt: id.
	resp code = 200
		ifTrue: [^ (N4Node id: id) db: self]! !

!N4GraphDb methodsFor: 'indexing' stamp: 'mu 2/16/2012 23:56'!
nodeIndexesNamed: indexName
	^self indexer nodeIndexesNamed: indexName! !

!N4GraphDb methodsFor: 'printing' stamp: 'mu 12/24/2011 15:29'!
printElementHeaderOn: aStream
	aStream nextPutAll: self elementName.
	aStream nextPut: $[.
	aStream nextPutAll: self restClient rootUri.
	aStream nextPut: $]
	! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 2/5/2012 16:43'!
queryByCypher: queryString
	^N4CypherResult json: (self restClient queryByCypher: queryString)! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/24/2011 23:30'!
relationshipAt: id 
	| resp |
	resp := self restClient getRelationshipAt: id.
	resp code = 200
		ifTrue: [^ (N4Relationship id: id) db: self]
	! !

!N4GraphDb methodsFor: 'indexing' stamp: 'mu 2/16/2012 23:56'!
relationshipIndexesNamed: indexName
	^self indexer relationshipIndexesNamed: indexName! !

!N4GraphDb methodsFor: 'actions' stamp: 'mu 12/13/2011 23:22'!
relationshipTypes
	^ self restClient getRelationshipTypes! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 2/19/2012 21:21'!
db: aGraphDb
	| inst |
	inst := self new.
	inst db: aGraphDb.
	^inst! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 12/13/2011 23:31'!
from: response
	^self id: (self portableUtil pickIdFrom: response location).
	! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 12/13/2011 23:50'!
id: anInteger 
	| inst |
	inst := self new.
	inst id: anInteger asInteger.
	^inst! !

!N4GraphObject class methodsFor: 'instance creation' stamp: 'mu 12/13/2011 23:53'!
json: jsonObject
	^self new
	! !

!N4GraphObject class methodsFor: 'accessing' stamp: 'mu 12/9/2011 00:42'!
portableUtil
	^N4PortableUtil default! !

!N4GraphObject methodsFor: 'compareing' stamp: 'mu 2/17/2012 00:03'!
= other
	^ self class = other class and: [self id = other id]! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/23/2011 13:38'!
at: propName 
	"shortcut"
	^self propertyAt: propName! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/23/2011 13:38'!
at: propName put: value
	"shortcut"
	^self propertyAt: propName put: value! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:26'!
db
	"Answer the value of db"

	^ db! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:26'!
db: anObject
	"Set the value of db"

	db := anObject! !

!N4GraphObject methodsFor: 'printing' stamp: 'mu 12/24/2011 15:18'!
elementName
	^self class name! !

!N4GraphObject methodsFor: 'compareing' stamp: 'mu 2/17/2012 00:03'!
hash
	^self id hash! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/9/2011 00:36'!
id
	"Answer the value of id"

	^ id! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/9/2011 00:36'!
id: anObject
	"Set the value of id"

	id := anObject! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 6/2/2012 21:51'!
portableUtil
	^self class portableUtil! !

!N4GraphObject methodsFor: 'printing' stamp: 'mu 12/24/2011 15:20'!
printElementHeaderOn: aStream
	aStream nextPutAll: self elementName.
	aStream nextPut: $[.
	aStream nextPutAll: self id printString.
	aStream nextPut: $]
	! !

!N4GraphObject methodsFor: 'printing' stamp: 'mu 12/24/2011 15:20'!
printOn: aStream
	self printElementHeaderOn: aStream! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:39'!
properties! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:39'!
properties: propAssocs! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:41'!
propertyAt: propName ! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/10/2011 23:41'!
propertyAt: propName put: value! !

!N4GraphObject methodsFor: 'properties' stamp: 'mu 12/13/2011 23:08'!
removePropertyAt: propName! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/8/2011 23:58'!
restClient

	^ restClient ifNil: [restClient := N4RestClient new]! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 12/8/2011 23:57'!
restClient: anObject
	"Set the value of restClient"

	restClient := anObject! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 6/2/2012 21:26'!
settings
	"Answer the value of settings"

	^ settings ifNil: [settings := N4Settings default]! !

!N4GraphObject methodsFor: 'accessing' stamp: 'mu 6/2/2012 21:26'!
settings: anObject
	"Set the value of settings"

	settings := anObject! !

N4GraphObject subclass: #N4Node
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

!N4Node class methodsFor: 'instance creation' stamp: 'mu 12/24/2011 23:04'!
json: jsonObject
	| inst |
	inst := self new.
	inst id: (self portableUtil pickIdFrom: (jsonObject at: 'self')).
	inst properties: (jsonObject at: 'data').
	^inst! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:13'!
all: type
	^self traversal returnRelationship relAll: type! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:15'!
allRelationships
	| jsons |
	jsons := self restClient getAllRelationshipsAt: self id.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:33'!
allRelationships: type
	| jsons |
	jsons := self restClient getAllRelationshipsAt: self id type: type.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'actions' stamp: 'mu 12/13/2011 23:01'!
delete
	^ self restClient deleteNodeAt: self id ! !

!N4Node methodsFor: 'printing' stamp: 'mu 12/24/2011 15:19'!
elementName
	^'node'! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:15'!
inRelationships
	| jsons |
	jsons := self restClient getInRelationshipsAt: self id.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:33'!
inRelationships: type
	| jsons |
	jsons := self restClient getInRelationshipsAt: self id type: type.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:26'!
incoming
	^self inRelationships! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:13'!
incoming: type
	^self traversal returnRelationship relIn: type! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:15'!
outRelationships
	| jsons |
	jsons := self restClient getOutRelationshipsAt: self id.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:32'!
outRelationships: type
	| jsons |
	jsons := self restClient getOutRelationshipsAt: self id type: type.
	^jsons collect: [:each | N4Relationship json: each for: self]! !

!N4Node methodsFor: 'accessing-relationships' stamp: 'mu 12/23/2011 13:13'!
outgoing
	^self outRelationships! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:13'!
outgoing: type
	^self traversal returnRelationship relOut: type! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/10/2011 23:42'!
properties
	^ self restClient getPropertiesNodeAt: self id ! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/10/2011 23:43'!
properties: propAssocs
	^ self restClient setProperties: propAssocs nodeAt: self id! !

!N4Node methodsFor: 'properties' stamp: 'mu 6/2/2012 21:53'!
propertyAt: propName
	| value |
	value := self restClient getProperty: propName nodeAt: self id.
	^ self portableUtil convertToNative: value using: self settings

! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/10/2011 23:41'!
propertyAt: propName put: value
	^ self restClient setProperty: propName to: value nodeAt: self id ! !

!N4Node methodsFor: 'relationships' stamp: 'BernatRomagosa 12/7/2012 12:35'!
relateTo: otherNode type: typeName
	| resp relationship |
	resp :=  self restClient createRelationshipAt: self id to: otherNode uri type: typeName.
	relationship :=(N4Relationship from: resp) db: self db.
	relationship type: typeName.	
	relationship startNodeId: self id.
	relationship endNodeId: otherNode id.
	relationship direction: #out.
	^relationship! !

!N4Node methodsFor: 'relationships' stamp: 'mu 12/25/2011 22:31'!
relateTo: otherNode type: typeName properties: assocs
	| resp relationship |
	resp :=  self restClient createRelationshipAt: self id to: otherNode uri type: typeName properties: assocs.
	relationship :=(N4Relationship from: resp) db: self db.
	relationship type: typeName.	
	relationship properties: assocs.	
	relationship startNodeId: self id.
	relationship endNodeId: otherNode id.
	relationship direction: #out.
	^relationship! !

!N4Node methodsFor: 'relationships' stamp: 'mu 2/13/2012 00:16'!
relateToNewNode: typeName 
	| newNode |
	newNode := self db createNode.
	self relateTo: newNode type: typeName.
	^newNode! !

!N4Node methodsFor: 'relationships' stamp: 'mu 2/13/2012 00:21'!
relateToNewNode: typeName nodePropertues: nodePropertues relationshipProperties: relProperties
	| newNode |
	newNode := self db createNode: nodePropertues.
	self relateTo: newNode type: typeName properties: relProperties.
	^newNode! !

!N4Node methodsFor: 'properties' stamp: 'mu 12/13/2011 23:07'!
removePropertyAt: propName
	^ self restClient deleteProperty: propName nodeAt: self id ! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 12:36'!
traversal
	^ N4Traversal from: self! !

!N4Node methodsFor: 'traversal' stamp: 'mu 1/22/2012 15:37'!
traversal: settingBlock
	| trav |
	trav := N4Traversal from: self.
	settingBlock value: trav.
	^trav! !

!N4Node methodsFor: 'accessing' stamp: 'mu 1/22/2012 15:04'!
types
	^ (self allRelationships collect: [:each | each type]) asSet! !

!N4Node methodsFor: 'accessing' stamp: 'mu 4/22/2012 14:42'!
uri
	^ self restClient rootUri, 'node/', self id asString! !

N4GraphObject subclass: #N4Relationship
	instanceVariableNames: 'type direction startNodeId endNodeId'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Neo4reSt-GraphModel'!

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 12/11/2011 00:12'!
from: response
	| inst |
	inst := super from: response.
	
	^inst! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 2/19/2012 21:17'!
json: jsonObject
	| inst |
	inst := self new.
	inst id: (self portableUtil pickIdFrom: (jsonObject at: 'self')).
	inst type: (jsonObject at: 'type').
	inst startNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'start')). 
	inst endNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'end')). 
	
	^inst! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 1/22/2012 14:51'!
json: jsonObject for: startNode
	| inst |
	inst := self new.
	inst id: (self portableUtil pickIdFrom: (jsonObject at: 'self')).
	inst type: (jsonObject at: 'type').
	inst startNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'start')). 
	inst endNodeId: (self portableUtil pickIdFrom: (jsonObject at: 'end')). 
	inst direction: ((inst startNodeId = startNode id) ifTrue: [#out] ifFalse: [#in]). 
	inst db: startNode db.
	^inst! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 12/10/2011 23:54'!
typed: typeName! !

!N4Relationship class methodsFor: 'instance creation' stamp: 'mu 12/10/2011 23:54'!
typed: typeName properties: props! !

!N4Relationship methodsFor: 'actions' stamp: 'mu 12/13/2011 23:01'!
delete
	^ self restClient deleteRelationshipAt: self id ! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
direction
	"Answer the value of direction"

	^ direction! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
direction: anObject
	"Set the value of direction"

	direction := anObject! !

!N4Relationship methodsFor: 'printing' stamp: 'mu 12/24/2011 15:19'!
elementName
	^'rel'! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:24'!
endNode
	^ self db nodeAt: self endNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
endNodeId
	"Answer the value of endNodeId"

	^ endNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
endNodeId: anObject
	"Set the value of endNodeId"

	endNodeId := anObject! !

!N4Relationship methodsFor: 'printing' stamp: 'mu 12/24/2011 15:21'!
printOn: aStream
	self printElementHeaderOn: aStream.
	aStream space.
	aStream nextPut: $(.
	aStream nextPutAll: self startNodeId asString.
	aStream nextPut: $).
	aStream space.
	self direction == #in ifTrue: [aStream nextPut: $<].
	aStream nextPut: $-.
	aStream nextPutAll: self type asString.
	aStream nextPut: $-.
	self direction == #out ifTrue: [aStream nextPut: $>].
	aStream space.
	aStream nextPut: $(.
	aStream nextPutAll: self endNodeId asString.
	aStream nextPut: $).! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/10/2011 23:44'!
properties
	^ self restClient getPropertiesRelationshipAt: self id ! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/10/2011 23:44'!
properties: propAssocs
	^ self restClient setProperties: propAssocs relationshipAt: self id! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 6/5/2012 09:29'!
propertyAt: propName
	| value |
	value := self restClient getProperty: propName relationshipAt: self id.
	^ self portableUtil convertToNative: value using: self settings! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/10/2011 23:44'!
propertyAt: propName put: value
	^ self restClient setProperty: propName to: value relationshipAt: self id ! !

!N4Relationship methodsFor: 'properties' stamp: 'mu 12/13/2011 23:08'!
removePropertyAt: propName
	^ self restClient deleteProperty: propName relationshipAt: self id ! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/24/2011 23:33'!
startNode
	^ self db nodeAt: self startNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
startNodeId
	"Answer the value of startNodeId"

	^ startNodeId! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/14/2011 00:01'!
startNodeId: anObject
	"Set the value of startNodeId"

	startNodeId := anObject! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
type
	"Answer the value of type"

	^ type! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 12/11/2011 00:14'!
type: anObject
	"Set the value of type"

	type := anObject! !

!N4Relationship methodsFor: 'accessing' stamp: 'mu 4/22/2012 22:44'!
uri
	^ self restClient rootUri, 'relationship/', self id asString! !
